%global dlrn_nvr os-brick-4.3.4-1.20230519140256.cf69f92
%global dlrn 1
%define upstream_version 4.3.4
%{!?sources_gpg: %{!?dlrn:%global sources_gpg 1} }
%global sources_gpg_sign 0xa7475c5f2122fec3f90343223fe3bf5aad1080e4
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global pypi_name os-brick

%global with_doc 0

# guard for Red Hat OpenStack Platform supported cinder
%global rhosp 1
%global common_desc \
OpenStack Cinder brick library for managing local volume attaches

Name:           python-%{pypi_name}
Version: 4.3.4
Release: 1.20230519140256.cf69f92%{?dist}
Summary:        OpenStack Cinder brick library for managing local volume attaches

License:        ASL 2.0
URL:            http://www.openstack.org/
Source0: os-brick-4.3.4-1.20230519140256.cf69f92.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=cf69f9247061bd0a945a6fb6bf688acff617eb2c
Patch0001: 0001-RHOS-Change-back-setup.cfg.patch
Patch0002: 0002-Read-HBA-information-from-sysfs.patch
Patch0003: 0003-RBD-Fix-disconnect_volume-for-encrypted-volumes.patch
Patch0004: 0004-PEP8-Don-t-force-name-in-TODO.patch
Patch0005: 0005-Don-t-log-error-trace-when-nvme-is-not-used.patch
Patch0006: 0006-LVM-Retry-lv-calls-on-segfault-due-to-lvs-failure.patch
Patch0007: 0007-Add-support-for-multiple-volumes-within-subsystem-to.patch
Patch0008: 0008-Fix-paths-for-NVMe-devices-non-nguid.patch
Patch0009: 0009-NVMeOF-connector-support-multipath-enabled-kernels.patch
Patch0010: 0010-nvmeof-connector-utilize-replica_count.patch
Patch0011: 0011-Reuse-get_host_nqn-code.patch
Patch0012: 0012-Robust-md-creation-ending.patch
Patch0013: 0013-nvmeof-connector-check-controller-already-connected.patch
Patch0014: 0014-NVMe-oF-Remove-misleading-exception-from-logs.patch
Patch0015: 0015-Add-NVMeoF-Multipathing-support.patch
Patch0016: 0016-Support-independent-file-lock-path.patch
Patch0017: 0017-LUKS-Support-extending-host-attached-volumes.patch
Patch0018: 0018-Fix-Unit-Test-failures-due-to-host-s-ANA-support.patch
Patch0019: 0019-NVMe-oF-Consolidate-code-paths.patch
Patch0020: 0020-NVMe-oF-Disconnect-subsystems.patch
Patch0021: 0021-Fix-nits-in-nvmeof-connector.patch
Patch0022: 0022-Add-flake8-logging-format-extension.patch
Patch0023: 0023-NVMe-oF-read-mdstat-in-Python.patch
Patch0024: 0024-NVMe-oF-Get-system-uuid-in-privsep.patch
Patch0025: 0025-Tests-Skip-nvmeof-test_get_md_name.patch
Patch0026: 0026-Support-force-disconnect-for-FC.patch
Patch0027: 0027-Support-separate-privsep-logging-levels.patch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
Source101:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{version}.tar.gz.asc
Source102:        https://releases.openstack.org/_static/%{sources_gpg_sign}.txt
%endif
BuildArch:      noarch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
BuildRequires:  /usr/bin/gpgv2
BuildRequires:  openstack-macros
%endif

%description
%{common_desc}

%package -n python3-%{pypi_name}
Summary:        OpenStack Cinder brick library for managing local volume attaches
%{?python_provide:%python_provide python3-%{pypi_name}}
Provides:       os-brick = %{version}-%{release}

Requires:       python3-pbr
Requires:       python3-eventlet >= 0.30.0
Requires:       python3-oslo-concurrency >= 4.4.0
Requires:       python3-oslo-context >= 3.1.1
Requires:       python3-oslo-i18n >= 5.0.1
Requires:       python3-oslo-log >= 4.4.0
Requires:       python3-oslo-serialization >= 4.1.0
Requires:       python3-oslo-service >= 2.5.0
Requires:       python3-oslo-utils >= 4.8.0
Requires:       python3-requests >= 2.25.1
Requires:       python3-oslo-privsep >= 2.4.0
Requires:       python3-os-win >= 5.4.0
Requires:       cryptsetup
Requires:       device-mapper-multipath
Requires:       iscsi-initiator-utils
Requires:       lsscsi >= 0.29
Requires:       lvm2
Requires:       nfs-utils
Requires:       nvme-cli
Requires:       sg3_utils
%if 0%{?rhosp} == 0
Requires:       sysfsutils
%endif
Requires:       systemd-udev

Requires:       python3-tenacity

BuildRequires:  openstack-macros
BuildRequires:  python3-devel
BuildRequires:  python3-ddt
BuildRequires:  python3-fixtures
BuildRequires:  python3-pbr >= 5.5.0
BuildRequires:  git-core
BuildRequires:  python3-reno
BuildRequires:  python3-oslo-concurrency  >= 4.4.0
BuildRequires:  python3-oslo-i18n >= 5.0.1
BuildRequires:  python3-oslo-log >= 4.4.0
BuildRequires:  python3-oslo-service >= 2.5.0
BuildRequires:  python3-os-win
BuildRequires:  python3-requests >= 2.25.1
BuildRequires:  python3-setuptools
BuildRequires:  python3-oslo-privsep >= 2.4.0
BuildRequires:  python3-oslo-vmware
BuildRequires:  python3-testtools

# Castellan is only for unit tests
BuildRequires:  python3-castellan

%if 0%{?with_doc}
BuildRequires:  python3-openstackdocstheme
BuildRequires:  python3-sphinx
%endif

BuildRequires:  python3-tenacity

%description -n python3-%{pypi_name}
%{common_desc}

%prep
# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
%{gpgverify}  --keyring=%{SOURCE102} --signature=%{SOURCE101} --data=%{SOURCE0}
%endif
%autosetup -n %{pypi_name}-%{upstream_version} -S git
%py_req_cleanup


%build
%{py3_build}

%check
python3 setup.py test

%install
%{py3_install}

%if 0%{?with_doc}
# generate html docs
sphinx-build-3 -b html doc/source doc/build/html
# remove the sphinx-build-3 leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

# Move config files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap
mv %{buildroot}/usr/etc/os-brick/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap

%files -n python3-%{pypi_name}
%license LICENSE
%if 0%{?with_doc}
%doc doc/build/html
%endif
%doc README.rst
%{python3_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%exclude %{python3_sitelib}/os_brick/tests

%changelog
* Fri May 19 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230519140256.cf69f92
- Update patches

* Thu May 18 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230518144012.cf69f92
- Support separate privsep logging levels (rhbz#2203238)

* Wed May 17 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230517133959.cf69f92
- Support force disconnect for FC (rhbz#2196915)

* Sat Jan 28 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230128063819.cf69f92
- Update patches

* Tue Jan 17 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230117183903.cf69f92
- Tests: Skip nvmeof test_get_md_name

* Tue Jan 17 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230117153810.cf69f92
- Update patches

* Wed Jan 11 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230111173802.cf69f92
- Add support for multiple volumes within subsystem to NVMe-OF connector (rhbz#1986025)
- PEP8: Don't force name in TODO

* Wed Jan 11 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230111144406.cf69f92
- NVMe-oF: Get system uuid in privsep (rhbz#1986025)
- NVMe-oF: read mdstat in Python (rhbz#1986025)
- Add flake8-logging-format extension (rhbz#1986025)
- Fix nits in nvmeof connector (rhbz#1986025)
- NVMe-oF: Disconnect subsystems (rhbz#1986025)
- NVMe-oF: Consolidate code paths (rhbz#1986025)
- Fix Unit Test failures due to host's ANA support (rhbz#1986025)
- LUKS: Support extending host attached volumes (rhbz#1986025)
- Support independent file lock path (rhbz#1986025)
- Add NVMeoF Multipathing support (rhbz#1986025)
- NVMe-oF: Remove misleading exception from logs (rhbz#1986025)
- nvmeof connector check controller already connected (rhbz#1986025)
- Robust md creation/ending (rhbz#1986025)
- Reuse get_host_nqn code (rhbz#1986025)
- nvmeof connector utilize replica_count (rhbz#1986025)
- NVMeOF connector support multipath-enabled kernels (rhbz#1986025)
- Add support for multiple volumes within subsystem to NVMe-OF connector (rhbz#1986025)
- RHOS:  Change back setup.cfg

* Tue Jan 10 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230110193842.cf69f92
- Fix paths for NVMe devices (non-nguid) (rhbz#1986025)
- Add support for multiple volumes within subsystem to NVMe-OF connector (rhbz#1986025)
- LVM: Retry lv calls on segfault due to lvs failure (rhbz#1986025)
- Don't log error trace when nvme is not used (rhbz#1986025)

* Tue Jan 10 2023 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20230110154013.cf69f92
- Update patches

* Thu Nov 10 2022 OSP Prod Chain <dev-null@redhat.com> 4.3.4-1.20221110063715.cf69f92
- Update patches
- Fix encryption symlink issues
- NVMe-oF: Return right nqn when missing hostnqn

* Wed Jul 27 2022 OSP Prod Chain <dev-null@redhat.com> 4.3.3-1.20220727161123.d09dc9e
- RBD: Fix disconnect_volume for encrypted volumes (rhbz#2106389)
- Read HBA information from sysfs (rhbz#1960179)

* Wed Jul 20 2022 OSP Prod Chain <dev-null@redhat.com> 4.3.3-1.20220720213833.d09dc9e
- Update patches

* Thu Jul 14 2022 OSP Prod Chain <dev-null@redhat.com> 4.3.3-1.20220714120657.d09dc9e
- Update patches

* Wed Jul 13 2022 OSP Prod Chain <dev-null@redhat.com> 4.3.3-1.20220713075758.d09dc9e
- Fix encryption symlink issues

* Sat Mar 12 2022 OSP Prod Chain <dev-null@redhat.com> 4.3.3-0.20220312062401.d09dc9e
- Update patches
- linuxscsi: Only raise and log multipathd errors when required
- Use file locks in connectors
- multipath/iscsi: iSCSI connections are not reinitiated after reboot

* Fri Sep 03 2021 OSP Prod Chain <dev-null@redhat.com> 4.3.2-0.20210903074603.0c7f5fc
- Update patches
- NVMe-oF: Flush on disconnect
- multipath/iscsi: remove devices from multipath monitoring
- Drop lower-constraints job

* Thu Aug 26 2021 OSP Prod Chain <dev-null@redhat.com> 4.3.1-0.20210826061818.f86944b
- Update patches

* Mon May 31 2021 OSP Prod Chain <dev-null@redhat.com> 4.3.1-0.20210531083033.f86944b
- Update patches

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 4.3.1-0.20210528054746.f86944b
- Update patches

* Tue Apr 06 2021 OSP Prod Chain <dev-null@redhat.com> 4.3.1-1
- Update patches
- Add release note prelude for os-brick 4.4.0
- iSCSI: Fix flushing after multipath cfg change
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby

* Wed Mar 24 2021 OSP Prod Chain <dev-null@redhat.com> 4.3.0-1
- Update patches

* Mon Mar 15 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Mar 15 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Sat Mar 13 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Mar 11 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- NVMeOF connector driver connection information compatibility fix
- Update requirements for wallaby release
- Move os-brick to new hacking 4.0.0
- Avoid unhandled exceptions during connecting to iSCSI portals
- Enforce import order with flake8-import-order
- Fix import order of libraries
- Remove six
- Changed minversion in tox to 3.18.0
- ScaleIO: More connection info backward compatibility
- Update TOX_CONSTRAINTS_FILE
- Add fixtures to test-reqs
- FC: Fix not flushing on detach

* Fri Feb 19 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- NVMeOF Connector support MDRAID replication
- opencas: Use BrickException instead of Exception
- Update requirements
- rbd Windows support
- Replace deprecated UPPER_CONSTRAINTS_FILE variable
- Improve error handling on target query
- Add timeout default to execute command

* Thu Jan 21 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Jan 20 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Tue Jan 19 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Dec 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Nov 20 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Oct 21 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Sep 18 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Sep 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Release note for os-brick 4.0.1
- New fix for rbd connector to work with ceph octopus
- Revert "Fix for rbd connector to work with ceph octopus"
- Update TOX_CONSTRAINTS_FILE for stable/victoria
- Update .gitreview for stable/victoria
- Fix for rbd connector to work with ceph octopus
- Add volume local cache support to os-brick
- Remove CORAID AOE connector
- Add note about removed cinder feature
- Fix pygments style
- Add code coverage job
- Add release note for scaleio connector upgrade
- Fix a typo in the explanatory note
- Leverage the iSCSI mpath to get the WWN
- bindep: remind people to sync the dependencies with devstack
- ScaleIO: Connection info backward compatibility
- Remove DRBD connector
- Remove Veritas Hyperscale connector
- Remove the HGST connector
- Remove the ITRI DISCO connector
- prepend platform info to by-path string
- RBD: Implement volume extension
- RBD: Fix check_valid_device
- RBD: Support non OpenStack usage
- Add doc linting to pep8 target
- iSCSI detect multipath DM with no WWN
- Improve WWN detection

* Tue Sep 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Aug 28 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Aug 27 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Aug 26 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Aug 17 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add TODO to switch to new style rbd commands
- Replace sg_scan with lsscsi to get '[H:C:T:L]'
- rbd: Warn if ceph udev rules are not configured
- Bump hacking to 3.1.0
- Remove translation sections from setup.cfg

* Mon Aug 03 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Switch from unittest2 compat methods to Python 3.x methods
- rbd: Support 'rbd showmapped' output from ceph 13.2.0+
- Fix os-brick in virtual environments
- Bump pycodestyle to 2.6.0
- Update lower-constraints versions
- Add iscsi-initiator-utils requirement
- Add oslo.context dependency
- Add oslo.serialization dependency

* Mon Jun 22 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Jun 05 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Remove VxFlex OS credentials from connection_properties
- Stop to use the __future__ module.
- Add dependencies to releasenotes environment
- Switch to newer openstackdocstheme and reno versions
- Fix hacking min version to 3.0.1
- rbd: Correct local_attach disconnect test and showmapped arguments
- Switch from retrying to tenacity
- Fix import order per hacking guidelines
- Remove Babel requirement
- Bump default tox env from py37 to py38
- Add py38 package metadata
- Use unittest.mock instead of third party mock
- Add Python3 victoria unit tests
- Cleanup py27 support
- Update master for stable/ussuri
- Add NFS tempest job to check queue

* Wed Apr 29 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Apr 29 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Apr 03 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add release note for ussuri cycle release
- rbd: Use showmapped to find the root RBD device during disconnect_volume
- doc/source/conf.py is not executable
- Ussuri contrib docs community goal
- connectors/nvme: Wait until nvme device shows up in kernel
- Raise hacking version to 2.0.0
- Port the os-bricks jobs to Zuul v3

* Thu Mar 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Mar 05 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Skip cryptsetup password quality checking
- Drop requirements for unsupported python versions
- Read mounts from /proc/mounts instead of running mount
- Remove Sheepdog connector
- StorPool: wait for the device to be resized.
- Remove Python 2.7 support from testing and gates
- StorPool: parse the output of `blockdev` correctly.
- Add linuxscsi get_device_info unit test

* Fri Dec 20 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Split connector list by platform"
- Merge "Fix tox 'bindep' environment"
- iscsi: Add _get_device_link retry when waiting for /dev/disk/by-id/ to populate
- Merge "Switch to Ussuri jobs"
- Merge "Blacklist eventlet 0.25.0"
- Merge "Update the constraints url"
- Merge "FC improve logging"
- Merge "Update FC connection_properties examples"
- Merge "Fix FC scan too broad"
- Fix tox 'bindep' environment
- Split connector list by platform
- FC improve logging
- Update FC connection_properties examples
- Fix FC scan too broad
- nvmeof: Fix broken UTs
- Merge "Require oslo.privsep 1.32.0"
- Merge "Remove VxFlexOS connector external dependencies"
- Remove VxFlexOS connector external dependencies
- Switch to Ussuri jobs
- nvmeof: Use subnqn to disconnect a volume
- Update the constraints url
- Require oslo.privsep 1.32.0
- Update master for stable/train
- Blacklist eventlet 0.25.0
- Change PDF file name

* Wed Nov 13 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches


